

FUNCTION TITL_SRCH
*t_search(), index key title search

*call as TITL_SRCH("TKEY","TITLE")

frame = chr(201) + chr(205) + chr(187) + chr(186) + chr(188) + chr(205) +;
  chr(200) + chr(186) + chr(32)

private ntxkey,titlefield,mb,mc,md,instring,waiter,marker,counter,endpos,linecnt,bigline,first,answer,val_answer,onerr

parameters ntxkey,titlefield

if pcount() <> 2
    return .f.
endif


DO WHILE .t.
    CLEAR
    STORE space(3) TO ma
    STORE space(2) TO mb
    STORE space(2) TO mc
    STORE space(1) TO md
    CLEAR

    @ 15,16 SAY "ͻ"
    @ 16,16 SAY " enter first three letters of first word in title     "
    @ 17,16 SAY "       first two letters of second word               "
    @ 18,16 SAY "       first two letters of third word                "
    @ 19,16 SAY "       first letter of fourth word                    "
    @ 20,16 SAY " if less than 4 words in title enter carriage returns "
    @ 21,16 SAY "ͼ"
    @ 9,19,11,48 box frame

    @ 10,20 SAY "SEARCH KEY:  " GET ma
    @ 10,37 SAY "," GET mb
    @ 10,41 SAY "," GET mc
    @ 10,45 SAY "," GET md
    READ

    STORE trim(ma) + trim(mb) + trim(mc) + trim(md) TO instring
    STORE upper(instring) TO instring
    IF len(trim(instring)) = 0
        CLEAR
        CLOSE databases
        RETURN .f.
    ENDIF

    IF len(instring) < 8
        STORE 8 - len(instring) TO fix
        STORE instring + space(fix) TO instring
    ENDIF len(instring) < 8

    SEEK instring

    IF eof() .OR. bof()
        save screen
        @ 10,15,13,57 box frame
        @ 11,16 SAY "This index key is not in the title index"
        @ 12,22 SAY "press any key to continue"
        INWAIT()
        restore screen
        LOOP
    ENDIF

    STORE recno() TO marker

    STORE 1 TO counter

    if .not. eof()

        DO WHILE upper(instring) = upper(&ntxkey .AND. .not. eof())
            SKIP
            STORE counter + 1 TO counter
        ENDDO
        store counter - 1 to endpos
        skip  -1
    endif

    *return to first record found
    GOTO MARKER

    DO WHILE .t.
        STORE 1 TO linecnt
        clear

        DO WHILE linecnt <= endpos .AND. .not. eof()

            STORE ltrim(trim(str(linecnt))) + ") " + trim(&titlefield) TO bigline

            IF len(trim(bigline)) > 73
                store trim(bigline) to bigline
                STORE substr(bigline,1,73) TO bigline
            ENDIF len(trim(bigline)) > 75

            ? trim(bigline)
            skip

            STORE linecnt + 1 TO linecnt

            IF linecnt = 20
                EXIT
            ENDIF

        ENDDO WHILE linecnt <= endpos .AND. .not. eof()

        DO WHILE .t.
            @ 24,0 clear
            @ 24,3 prompt "Accept item #"
            @ 24,20 prompt "Next screen"
            @ 24,37 prompt "Previous screen"
            @ 24,60 prompt "Quit search"
            menu to answer
            do case

                case answer = 0 .or. answer = 4
                    clear
                    close data
                    return .f.

                case answer = 1
                    save  screen
                    @ 10,20,12,40 box frame
                    store 0 to item
                    @ 11,21 say "Enter item # " get item picture "9999"
                    read
                    restore screen
                    if item < 1 .or. item > endpos
                        loop
                    endif
                    goto marker
                    skip item
                    return .t.

                case answer = 2 .and. linecnt < endpos
                    SKIP
                    CLEAR
                    EXIT
                case answer = 3 .AND. linecnt > 20
                    STORE 1 TO COUNT
                    DO WHILE COUNT < 20 .AND. .not. bof()
                        SKIP - 1
                        STORE linecnt - 1 TO linecnt
                    ENDDO

                    CLEAR
                    EXIT
            ENDCASE
        ENDDO
    ENDDO
ENDDO


*************************************************************

FUNCTION T_SEARCH
private ma,mb,mc,md,instring,fix,counter,endpos,answer

PARAMETERS ntxkey,prog_name

if pcount() <> 2
    return .f.
endif

*call as T_SSEARCH("TKEY",progname)
*requires index compatible with titl_key()
*prog_name: name of procedure to display individual records.


frame = chr(201) + chr(205) + chr(187) + chr(186) + chr(188) + chr(205) +;
  chr(200) + chr(186) + chr(32)

DO WHILE .t.
    CLEAR
    STORE space(3) TO ma
    STORE space(2) TO mb
    STORE space(2) TO mc
    STORE space(1) TO md
    CLEAR

    @ 15,16 SAY "ͻ"
    @ 16,16 SAY " enter first three letters of first word in title     "
    @ 17,16 SAY "       first two letters of second word               "
    @ 18,16 SAY "       first two letters of third word                "
    @ 19,16 SAY "       first letter of fourth word                    "
    @ 20,16 SAY " if less than 4 words in title enter carriage returns "
    @ 21,16 SAY "ͼ"
    @ 9,19,11,48 box frame
    @ 10,20 SAY "search key:  " GET ma
    @ 10,37 SAY "," GET mb
    @ 10,41 SAY "," GET mc
    @ 10,45 SAY "," GET md
    READ
    IF lastkey() = 27
        CLEAR
        CLOSE databases
        RETURN .f.
    ENDIF lastkey() = 27
    STORE trim(ma) + trim(mb) + trim(mc) + trim(md) TO instring
    STORE upper(instring) TO instring
    IF len(trim(instring)) = 0
        CLEAR
        RETURN .f.
    ENDIF len(trim(instring)) = 0
    GO TOP
    IF eof()
        CLEAR
        @ 5,0 SAY "No records in database to search"
        WAIT
        RETURN .f.
    ENDIF eof()
    IF len(instring) < 8
        STORE 8 - len(instring) TO fix
        STORE instring + space(fix) TO instring
    ENDIF len(instring) < 8
    SEEK instring
    IF eof() .OR. bof()
        frame = chr(201) + chr(205) + chr(187) + chr(186) + chr(188) +;
          chr(205) + chr(200) + chr(186) + chr(32)
        SAVE SCREEN
        @ 10,15,13,57 box frame
        @ 11,16 SAY "This index key is not in the title index"
        @ 12,24 SAY "press any key to continue"
        inkey(0)
        RESTORE SCREEN
        LOOP
    ENDIF eof() .OR. bof()
    STORE 1 TO counter
    DO WHILE instring = &NTXKEY .AND. .not. eof()
        SKIP
        STORE counter + 1 TO counter
    ENDDO WHILE
    IF .not. bof()
        STORE counter -1 TO endpos
    ENDIF .not. bof()
    DO WHILE counter > 1
        STORE counter - 1 TO counter
        SKIP - 1
    ENDDO WHILE counter > 1

    DO &prog_name

    DO WHILE .t.
        @ 24,0 CLEAR
        @ 24,55 SAY "Record " + ltrim(trim(str(counter))) +  " of " + ltrim(trim(str(endpos)))

        @ 24,5 prompt "Accept record"
        @ 24,20 prompt "Previous"
        @ 24,32 prompt "Next"
        @ 24,40 prompt "Quit search"

        menu to answer
        do case
            case answer = 0 .or. answer = 4
                clear
                close data
                return .f.
            case answer = 1
                clear
                return .t.

            CASE answer = 2 .and. counter >= 1
                SKIP -1
                STORE counter - 1 TO counter
                DO &prog_name
                LOOP
            case ANSWER = 3 .and. counter < endpos

                skip
                store counter + 1 to counter
                DO &prog_name
                LOOP
        ENDCASE
    ENDDO WHILE .t.
ENDDO WHILE .t.


***********************************************************************


FUNCTION AUT_SRCH

private morescreens,loopme,term,fix,waiter,aufind,tempfind,tlen,;
  many,setnum,answera,first,printme,counter,answer,setter,countme,pcount,choice


parameters ntxfield,searchfield,prog1,prog2,page_count

if pcount() <> 5
    return .f.
endif

if type("page_count") <> "N"
    return .f.
endif

frame = chr(201) + chr(205) + chr(187) + chr(186) + chr(188) + chr(205) +;
  chr(200) + chr(186) + chr(32)
set wrap on

*prog1: to display individual records
*prog2: to print multiple record sets
*pagecount, number of records / page
*printed by prog2 before issuing line feed

*requires index compatible with AUT_KEY() function
*store 3 to pagecount
*call as: AUT_SRCH("INDEXFIELD",COMPAREFIELD",prog1,prog2,pagecount)
* ALTERNATE CALL: store "LNAME + FNAME + MID" to show
*         AUT_SRCH("INDEXFIELD",SHOW,prog1,prog2,pagecount)

*requires bibliographic record
*indexed on AUT_KEY compatible index
* usage: select 1
* use main_file index &ntxfield
workarea = select()

select 9
if .not. file ("tempsrch.dbf" )
    create temp
    use temp
    append blank
    replace field_name with "SFIND"
    replace field_type with "C"
    replace field_len with 50
    append blank
    replace field_name with "BIBNUM"
    replace field_type with "N"
    replace field_len with 4
    append blank
    replace field_name with "NUMSUBS"
    replace field_type with "N"
    replace field_len with 4
    use
    create tempsrch from temp
    erase temp.dbf
endif

use tempsrch
zap


STORE "F" TO morescreens
STORE "F" TO redisplay
STORE "F" TO loopme
STORE "T" TO firstone
*select data areas
*workarea =  select(), bibliographic area
*9 tempsrch area

CLEAR
DO WHILE .t.
    select 9
    zap
    select (workarea)
    STORE space(4) TO a
    store space(3) to b
    store space(1) to c
    @ 8,19,16,54 box frame

    @ 9,20 SAY "Enter index key for author search"
    @ 11,20 say "4 letters of last name"
    @ 12,20 SAY "3 letters of first name"
    @ 13,20 say "1 letter of middle initial"

    @ 15,24 SAY "===> " GET a
    @ 15,34 say "," get b
    @ 15,39 say "," get c
    read

    store trim(a) + trim(b) + trim(c) to term
    store upper(term) to term

    if len(term) < 8
        store 8 - len(term) to fix
        store term + space(fix) to term
    endif

    IF len(trim(term)) = 0
        CLEAR
        SELECT 9
        ZAP
        CLOSE databases
        RETURN .f.
    ENDIF len(trim(term)) = 0

    SEEK term

    IF eof() .OR. bof()
        save screen
        @ 11,19,14,65 box frame
        @ 12,20 SAY "This ITEM is not in the database"
        @ 13,24 SAY "press any key to continue"
        INWAIT()
        restore screen
        LOOP
    ENDIF eof() .OR. bof()
    STORE recno() TO first
    STORE recno() TO startpos

    STORE trim(upper(&searchfield)) to aufind
    STORE trim(upper(&searchfield)) to tempfind

    STORE 0 TO tau
    store len(trim(upper(term))) to tlen
    ** tau --total number of authors headings found
    STORE 0 TO counter
    ** counter --number of records per heading
    *store record number of first find
    *count number of hits for term by subdivision
    set exact on
    DO WHILE trim(upper(term)) = substr(trim(upper(&ntxfield)),1,tlen) .and. ;
          .not. eof()
        STORE tau + 1 TO tau
        STORE recno() TO first
        DO WHILE aufind = tempfind .AND. .not. eof()
            STORE counter + 1 TO counter
            IF eof()
                EXIT
            ENDIF eof()
            SKIP
            STORE trim(upper(&searchfield)) TO tempfind
        ENDDO
        set exact off
        SELECT 9
        APPEND BLANK

        REPLACE bibnum WITH first
        REPLACE sfind WITH aufind
        REPLACE numsubs WITH counter
        STORE 0 TO counter
        SELECT (workarea)
        IF eof()
            EXIT
        ENDIF eof()
        IF trim(upper(term)) = substr(trim(upper(&ntxfield)),1,tlen)
            STORE trim(upper(&searchfield)) TO aufind
        ENDIF
    ENDDO
    GOTO startpos
    *display retrieved items
    STORE 1 TO setnum
    STORE 0 TO times15
    CLEAR


    DO WHILE .t.
        *return to here
        *to redisplay set listing
        STORE setnum TO xcheck
        if tau > 1
            store "ITEMS" to num
        else
            store "ITEM" to num
        endif
        @ 1,20 SAY trim(str(tau)) +  "  " + num + " FOUND"

        SELECT 9
        IF loopme = "F"
            GO TOP
        ENDIF loopme = "F"
        STORE "F" TO loopme
        STORE 1 TO subcount
        STORE 3 TO linecount

        DO WHILE subcount < 15 .AND. .not. eof()
            IF numsubs > 1 .OR. numsubs = 0
                STORE "records" TO word
            ELSE
                STORE "record" TO word
            ENDIF numsubs > 1 .OR. numsubs = 0

            if len(sfind) < 40
                store sfind to showfind
            else
                store substr(sfind,1,40) to showfind
            endif


            @ linecount,0 SAY "SET # " + ltrim(trim(str(setnum))) + " (" +   ;
              ltrim(trim(str(numsubs))) + " " + word + ") " + showfind

            STORE setnum + 1 TO setnum
            STORE linecount + 1 TO linecount
            STORE subcount + 1 TO subcount
            SKIP
        ENDDO WHILE subcount < 15 .AND. .not. eof()

        STORE subcount - 1 TO subcount
        DO WHILE .t.
            @ 24,1 prompt "Set number"
            @ 24,13 prompt "Quit search"
            @ 24,27 prompt "Next screen"
            @ 24,42 prompt "Previous screen"
            @ 24,60 prompt "Print set"
            menu to choice

            do case
                CASE choice = 1
                    save screen
                    @ 10,20,12,40 box frame
                    store 0 to answer
                    @ 11,21 say "Set # " get answer picture "##"
                    read
                    restore screen

                    IF answer > subcount  .or. answer <= 0
                        LOOP
                    ENDIF

                    IF answer <= subcount
                        GOTO answer
                        EXIT
                    ENDIF

                CASE choice = 2 .or. choice = 0
                    CLEAR
                    select 9
                    ZAP
                    CLOSE databases
                    RETURN .f.

                CASE choice = 3 .and. .not. eof()

                    STORE 3 TO linecount
                    STORE "T" TO redisplay
                    STORE times15 + 1 TO times15
                    STORE 1 TO setnum
                    STORE "T" TO loopme
                    CLEAR
                    EXIT

                CASE choice = 4 .and.  subcount > 15
                    STORE 0 TO countme
                    DO WHILE .not. bof() .AND. countme < 16
                        SKIP -1
                        STORE 1 TO setnum
                        STORE countme + 1 TO countme
                    ENDDO
                    STORE times15 -1 TO times15
                    STORE "T" TO loopme
                    CLEAR
                    EXIT

                case choice = 5
                    STORE "T" TO loopme
                    SAVE SCREEN
                    @ 15,20,18,60 box frame
                    STORE 0 TO setter
                    @ 16,21 SAY "Enter set number to print " GET setter picture "##"
                    READ
                    restore screen
                    IF setter  <=0 .or. lastkey() = 27
                        loop
                    ENDIF
                    IF setter > tau
                        LOOP
                    endif

                    IF noprint()
                        LOOP
                    endif

                    SELECT 9
                    GOTO (times15 * 15) + setter
                    set relation to bibnum into a
                    SAVE SCREEN
                    @ 10,30,15,60 box frame
                    @ 11,31 SAY "Printing set " + ltrim(trim(str(setter)))
                    STORE numsubs TO foundper
                    STORE bibnum TO foundnum
                    SELECT (workarea)
                    *find subject heading
                    GOTO foundnum
                    STORE 0 TO countme
                    STORE 0 TO pcount
                    DO WHILE countme < foundper .AND. .not. eof()

                        DO &PROG2

                        STORE countme + 1 TO countme
                        STORE pcount + 1 TO pcount
                        IF lastkey() = 27
                            RESTORE SCREEN
                            LOOP
                        ENDIF lastkey() = 27
                        IF pcount = page_count
                            EJECT
                            STORE 0 TO pcount
                        ENDIF
                        SELECT (workarea)
                        SKIP
                    ENDDO WHILE countme < foundper .AND. .not. eof()

                    SELECT 9
                    STORE 1 TO setnum
                    STORE 0 TO times15
                    GO TOP
                    EXIT
                OTHERWISE
                    LOOP
            ENDCASE

            IF loopme = "T"
                LOOP
            ENDIF

            IF choice = 3
                STORE 2 TO linecount
                STORE 1 TO subcount
                CLEAR
                LOOP
            ENDIF

        ENDDO

        SELECT 9
        GOTO (times15 * 15) + answer
        * first searchfield record for subdivision
        STORE sfind TO foundhead
        STORE bibnum TO foundnum
        STORE numsubs TO foundper
        * number of matching headings per subdivision
        *find subject heading
        STORE 1 TO shown
        * number of record/set currently displayed
        *display records
        SELECT (workarea)
        GOTO foundnum
        STORE answer TO thisone

        DO WHILE .t.
            CLEAR
            DO &PROG1
            do while .t.

                store "Record # " + ltrim(trim(str(shown))) + " of ";
                  + ltrim(trim(str(foundper))) + " for this set" to line
                @ 23,0 say str_center(line)

                @ 24,1 prompt  "Previous"
                @ 24,13 prompt "Next"
                @ 24,20 prompt "Print"
                @ 24,29 prompt "Accept"
                @ 24,39 prompt "Return to sets"
                @ 24,57 prompt "Quit search"
                menu to answera
                DO CASE
                    CASE answera = 6 .or. answera = 0
                        CLEAR
                        SELECT 9
                        ZAP
                        CLOSE databases
                        RETURN .f.

                    CASE (answera = 1 .AND. shown > 1) .AND. .not. bof()
                        SELECT (workarea)
                        SKIP -1
                        STORE shown - 1 TO shown
                        exit

                    CASE (answera = 2 .AND. shown < foundper) .AND. .NOT. EOF()
                        select (workarea)
                        SKIP
                        STORE shown + 1 TO shown
                        exit

                    CASE answera = 3
                        if noprint()
                            loop
                        ENDIF
                        DO &PROG2
                        LOOP
                        exit

                    CASE answera = 4
                        select 9
                        zap
                        clear
                        return .t.

                    CASE answera = 5
                        CLEAR
                        STORE "F" TO loopme
                        STORE 1 TO setnum
                        EXIT

                    OTHERWISE
                        LOOP
                ENDCASE
            enddo
            if answera = 5
                exit
            endif

        ENDDO

    ENDDO
ENDDO

***********************************

PROCEDURE STR_SRCH

*call as DO STR_SRCH with prog1,prog2,prog3
*prog1 = display, prog2 = edit, prog3 = format for printing

parameters fld_name,prog1,prog2,prog3

SET WRAP ON
frame = chr(201) + chr(205) + chr(187) + chr(186) + chr(188) + chr(205) + chr(200) + chr(186) + chr(32)

DO WHILE .t.
    clear
    @ 3,5 SAY "You may search for a " + fld_name + " using up to three words"
    @ 4,5 SAY "included in the name.  If you specify fewer than"
    @ 5,5 SAY "three, enter carriage returns in the remaining"
    @ 6,5 SAY "spaces. enter three carriage returns to return to menu"
    STORE space(20) TO w1
    STORE space(20) TO w2
    STORE space(20) TO w3
    @ 8,6 SAY 'Keyword  ' GET w1
    @ 9,6 SAY 'Keyword  ' GET w2
    @ 10,6 SAY 'Keyword  ' GET w3
    READ
    IF w1= space(20) .AND. w2 = space(20) .AND. w3 = space(20)
        CLEAR
        STORE " " TO answer
        RETURN
    ENDIF w1= space(20) .AND. w2 = space(20) .AND. w3 = space(20)

    STORE upper(trim(w1)) TO k1
    STORE upper(trim(w2)) TO k2
    STORE upper(trim(w3)) TO k3
    @ 14,5 SAY "You may search for a " + fld_name + " that contains"
    @ 15,5 SAY "ALL of the keywords that you have specified"
    @ 16,5 SAY "or you may search for a " + fld_name + " that contains"
    @ 17,5 SAY "any ONE of the keyterms that you have specified."
    @ 19,15 prompt  "A)ll"
    @ 19,21 prompt "O)ne"
    menu to query
    DO CASE
        case query = 0
            clear
            close databases
            return

        CASE query = 1
            go top
            IF len(k1) = 0
                STORE " " TO k1
            ENDIF len(k1) = 0
            IF len(k2) = 0
                STORE " " TO k2
            ENDIF len(k2) = 0
            IF len(k3) = 0
                STORE " " TO k3
            ENDIF len(k3) = 0
            @ 15,15,17,30 box frame
            @ 16,16 say "Searching..."
            LOCATE FOR k1 $ upper(&fld_name) .AND. k2 $ upper(&fld_name) .AND. k3 $ upper(&fld_name)
        CASE query = 2
            go top
            @ 15,15,17,30 box frame
            @ 16,16 say "Searching..."
            LOCATE FOR k1 $ upper(&fld_name) .OR. k2 $ upper(&fld_name) .OR. k3 $ upper(&fld_name)
    ENDCASE

    IF eof()
        @ 16,15,19,41 box frame
        @ 17,16 SAY 'Matching record not found'
        @ 18,16 say 'Press any key to continue'
        inwait()
        LOOP
    ENDIF eof()

    DO WHILE .t.
        DO &prog1

        @ 24,2 prompt "E)dit / D)elete"
        @ 24,20 prompt "C)ontinue search"
        @ 24,40 prompt "P)rint this record"
        @ 24,60 prompt "Q)uit this search"

        menu to answer

        DO CASE

            CASE answer = 1
                do bar_edit with prog2,prog3
                LOOP

            CASE answer = 2
                CLEAR
                @ 10,5,14,75 box frame
                @ 11,11 say "Searching for records"
                if query = 1
                    store "AND" to answer1
                endif
                if query = 2
                    store "OR" to answer1
                endif
                @ 12,11 say "Terms: " + answer1 + "(" + k1 + "," + k2 + "," + k3 + ")"

                CONTINUE
                IF eof()
                    @ 10,10,13,50 box frame
                    @ 11,11 say 'No more matching records found '
                    @ 12,11 say 'Press any key to continue'
                    inwait()
                    EXIT
                ENDIF eof()

            CASE answer = 3
                do &prog3
                loop

            CASE answer = 0 .or. answer = 4
                clear
                close data
                return

        ENDCASE
    ENDDO
ENDDO

****************************************************************************

PROCEDURE BOOLSRCH


*BOOLSRCH.prg
*Call as DO BOOLSRCH with "fieldname",prog1,prog2,prog3
*prog1 = display records
*prog2 = edit records
*prog3 = print record

parameters fieldname,prog1,prog2,prog3

CLEAR

private a1,a2,a3,b1,b2,b3,c1,c2,c3
frame = chr(201) + chr(205) + chr(187) + chr(186) + chr(188) + chr(205) + chr(200) + chr(186) + chr(32)
do while .t.
    @ 0,0 clear
    go top

    if eof()
        clear
        @ 5,20 say "No records in database to search"
        @ 6,31 say "press any key"
        inwait()
        clear
        close data
        return
    endif


    set console on
    store space(15) to a1,a2,a3,b1,b2,b3,c1,c2,c3

    @ 3,30 say "BOOLEAN STRING SEARCH"

    @ 5,14 say "AND"
    @ 5,37 say "OR"
    @ 5,61 say "NOT"

    @ 6,5 say "1)"
    @ 7,5 say "2)"
    @ 8,5 say "3)"
    @ 6,27 say "4)"
    @ 7,27 say "5)"
    @ 8,27 say "6)"
    @ 6,52 say "7)"
    @ 7,52 say "8)"
    @ 8,52 say "9)"


    @ 12,10 say "Enter search terms in the spaces provided"

    @ 14,9,21,62 box frame

    @ 15,10 say "AND ==> ALL the terms listed must be present"
    @ 17,10 say "OR  ==> ANY ONE of the terms listed must be present"
    @ 19,10 say "NOT ==> NONE of the terms listed should be present"
    @ 20,10 say "      press <esc> to return without searching"
    set cursor on

    @ 6,8 get a1
    @ 7,8 get a2
    @ 8,8 get a3
    @ 6,30 get b1
    @ 7,30 get b2
    @ 8,30 get b3
    @ 6,55 get c1
    @ 7,55 get c2
    @ 8,55 get c3

    read

    if lastkey() = 27
        clear
        close data
        return
    endif

    set cursor off

    store ltrim(trim(upper(a1))) to a1
    store ltrim(trim(upper(a2))) to a2
    store ltrim(trim(upper(a3))) to a3
    store ltrim(trim(upper(b1))) to b1
    store ltrim(trim(upper(b2))) to b2
    store ltrim(trim(upper(b3))) to b3
    store ltrim(trim(upper(c1))) to c1
    store ltrim(trim(upper(c2))) to c2
    store ltrim(trim(upper(c3))) to c3

    if len(a1) = 0  .and. len(a2) = 0 .and. len(a3) = 0;;
          .and. len(b1) =  0 .and. len(b2) =  0 .and. len(b3) = 0;
          .and. len(c1) = 0 .and. len(c2) = 0 .and. len(c3) = 0
        clear
        close data
        return
    endif

    if len(trim(a1)) = 0
        store " " to a1
    endif
    if len(trim(a2)) = 0
        store " " to a2
    endif
    if len(trim(a3)) = 0
        store " " to a3
    endif



    store "(a1 $ upper(&fieldname) .and. a2 $ upper(&fieldname) .and. a3 $ upper(&fieldname))" to s1
    store "(b1 $ upper(&fieldname) .or. b2 $ upper(&fieldname) .or. b3 $ upper(&fieldname))" to s2

    STORE A1 + A2 + A3 TO TESTLEN
    IF LEN(trim(TESTLEN)) = 0
        STORE S2 TO S4
    ELSE
        store s1 + " .or. " + s2  to s4
    ENDIF

    @ 10,20,12,43 box frame
    @ 11,21 say "Searching  &fieldname"

    go top
    locate for &s4
    if eof()
        CLEAR
        @ 10,20,13,47 box frame
        @ 11,21 say "No matching entries found"
        @ 12,21 say "press any key.."
        inwait()
        loop
    endif



    DO WHILE .NOT. EOF()


        if c1 $ upper(&fieldname) .or. c2 $ upper(&fieldname) .or. c3 $ upper(&fieldname)
            continue
        else

            DO &prog1
            DO BAR_EDIT with prog2,prog3

            @ 24,0 clear
            @ 24,12 say "Press space bar to continue search, any other key finishes"
            wait " " to waiter
            IF waiter <> " "
                CLEAR
                CLOSE databases
                RETURN
            ENDIF

            CONTINUE
            ***************************************
            if eof()
                CLEAR
                @ 5,20  say "ͻ"
                @ 6,20 SAY  "no more matching entries found  "
                @ 7,20 say  "ͼ"
                inwait()
                EXIT
            ENDIF eof()
        endif

    ENDDO
ENDDO
